#include "FtpLibrary.h"

STATUS FtpConnect (FTP **con, char *hostname)
{
  struct sockaddr_in unit;
  register struct hostent *host;
  register struct servent *service;
  String S1;
  STATUS x;
  
  *con = (FTP *) malloc (sizeof (FTP));
  
  (*con) -> sock = -1;
  (*con) -> mode = 'A';
  (*con) -> datafile = (FILE *) 0;
  (*con) -> datasock = -1;
  (*con) -> func = NULL;
  (*con) -> debug = NULL;
  (*con) -> lastmsg = NULL;
  
  if ((host = gethostbyname (hostname)) == 0)
    EXIT((*con),QUIT,return);

/* For some reason getservbyname has problems when the UCX stub routine is
   used. */

#ifndef VMS
  if ((service = (struct servent *) getservbyname("ftp","tcp"))==0)
    EXIT((*con),QUIT,return);
#endif  /* VMS */
  
  unit.sin_family = host -> h_addrtype;
  
  bcopy (host->h_addr_list[0], &unit.sin_addr, host->h_length);
  if ( ( (*con)->sock = socket (unit.sin_family, SOCK_STREAM, 0)) < 0)
    EXIT((*con),QUIT,return);

#ifndef VMS
  unit.sin_port = service -> s_port;
#else   /* VMS */
  unit.sin_port = htons(21);
#endif  /* VMS */

  while (connect ( (*con)->sock, (struct sockaddr *) &unit, sizeof unit ) < 0)
    {
      close ((*con)->sock);
      host->h_addr_list++;
      if (host->h_addr_list[0] == NULL)
        EXIT((*con),QUIT,return);
      bcopy (host->h_addr_list[0], &unit.sin_addr, host->h_length);
      if ( ( (*con)->sock = socket (unit.sin_family, SOCK_STREAM , 0)) < 0)
        EXIT((*con),QUIT,return);
    }
  
  if ( (x = FtpGetMessage(*con, S1)) == QUIT )
    EXIT((*con),QUIT,return);
  if ( ! FtpGood (x) )
    {
      close ((*con)->sock);
      (*con) -> sock = -1;
      EXIT((*con),-x,return);
    }
  EXIT((*con),x,return);
}
